unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Hlpwrite, StdCtrls, Buttons, Grids, DBGrids, ExtCtrls,
  DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Panel1: TPanel;
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    sd: TSaveDialog;
    CheckBox1: TCheckBox;
    hlp: THlpWriter;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
    ts:Tstringlist;
    bmp:TBitmap;
    procedure report;
    procedure addtopic;
    procedure createindex;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if sd.execute then
    begin
    hlp.filename := sd.filename;
    report;
    end;
end;

procedure TForm1.addtopic;
var bmpfile:string;
begin
  with table1 do
    begin
    hlp.defineTopicID(fieldbyname('Species No').AsString);
    hlp.defineTitle(fieldbyname('Species Name').AsString);
    hlp.defineKeyWords(fieldbyname('Species Name').AsString + '; ' +
          fieldbyname('Common_Name').AsString + '; ' +
          fieldbyname('Category').AsString);
    hlp.addtoIndex(1,fieldbyname('Species Name').AsString,
          fieldbyname('Species Name').AsString,false);
    hlp.addtoIndex(1,fieldbyname('Common_Name').AsString,
          fieldbyname('Common_Name').AsString,false);
    hlp.addTitle(fieldbyname('Species Name').AsString);
    hlp.addln('');
    hlp.add('Common Name: ');
    hlp.addbold(fieldbyname('Common_Name').AsString);
    hlp.addln('');
    hlp.add('Category: ');
    hlp.addln(fieldbyname('Category').AsString);
    hlp.add('Expected length: ');
    hlp.add(fieldbyname('Length (cm)').AsString);
    hlp.addln(' (' + fieldbyname('Length_In').AsString + ' inches)');
    hlp.addln('');
    ts.assign(tMemoField(fieldbyname('Notes')));
    if ts.count > 0 then hlp.addmemo(ts);
    if checkbox1.checked then
      begin
      hlp.addln('');

      {there is 2 ways to add bitmaps:
        option 1 is a little more direct and a lot more managable,
            although a lot more likely to crash hc
        option 2 gives a little more flexibility in bitmap placement
            and is less likely to crash hc, but makes file management
            more difficult
        (note: hc has memory problems with bitmaps. hcw is fine either way)}
    {option 1:
      bmp.assign(TBlobField(fieldbyname('Graphic')));
      hlp.insertbitmap(bmp);}
    {option 2:}
      bmp.assign(TBlobField(fieldbyname('Graphic')));
      bmpfile := extractfilepath(hlp.filename) + '\b'
          + fieldbyname('Species No').AsString + '.bmp';
           {use db key to get unique filename}
      bmp.savetofile(bmpfile);
      hlp.insertbmref(bm_left, false, extractfilename(bmpFile));
      end;
    hlp.endtopic;
    end;
end;

procedure TForm1.createindex;
begin
  hlp.defineTopicID('contents');
  hlp.markAsIndex(1, true);  {create button bar}
  hlp.definekeywords('index; contents');
  hlp.defineTitle('Index');
  hlp.addTitle('Index of Biolife database');
  hlp.addln('');
  hlp.insertindexentries;
  hlp.addln('');
  hlp.addln('copyright  Grahame Grieve');
  hlp.endtopic;
end;

procedure TForm1.report;
begin
  ts := TStringlist.create;
  bmp := TBitmap.create;
  try
    hlp.open := true;
    hlp.defineindex(1);
    with table1 do
      begin
      first;
      while not eof do
        begin
        addtopic;
        next;
        end;
      end;
    createindex;
    hlp.open := false;
  finally
    ts.free;
    bmp.free;
  end;
  messagedlg('Finished writing ' + hlp.filename + '. Ready for HC compile',
        mtinformation, [mbok], 0);
end;

end.
